// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct OpalEdge : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static OpalEdge GetRootAsOpalEdge(ByteBuffer _bb) { return GetRootAsOpalEdge(_bb, new OpalEdge()); }
  public static OpalEdge GetRootAsOpalEdge(ByteBuffer _bb, OpalEdge obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public OpalEdge __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public Veneris.Communications.Vec3? P { get { int o = __p.__offset(4); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? V { get { int o = __p.__offset(6); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? FaceA { get { int o = __p.__offset(8); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? FaceB { get { int o = __p.__offset(10); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? NormalA { get { int o = __p.__offset(12); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.Vec3? NormalB { get { int o = __p.__offset(14); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public Veneris.Communications.MaterialEMP? Material { get { int o = __p.__offset(16); return o != 0 ? (Veneris.Communications.MaterialEMP?)(new Veneris.Communications.MaterialEMP()).__assign(o + __p.bb_pos, __p.bb) : null; } }
  public uint Faid { get { int o = __p.__offset(18); return o != 0 ? __p.bb.GetUint(o + __p.bb_pos) : (uint)0; } }
  public uint Fbid { get { int o = __p.__offset(20); return o != 0 ? __p.bb.GetUint(o + __p.bb_pos) : (uint)0; } }
  public int Id { get { int o = __p.__offset(22); return o != 0 ? __p.bb.GetInt(o + __p.bb_pos) : (int)0; } }

  public static void StartOpalEdge(FlatBufferBuilder builder) { builder.StartTable(10); }
  public static void AddP(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> pOffset) { builder.AddStruct(0, pOffset.Value, 0); }
  public static void AddV(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> vOffset) { builder.AddStruct(1, vOffset.Value, 0); }
  public static void AddFaceA(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> faceAOffset) { builder.AddStruct(2, faceAOffset.Value, 0); }
  public static void AddFaceB(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> faceBOffset) { builder.AddStruct(3, faceBOffset.Value, 0); }
  public static void AddNormalA(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> normalAOffset) { builder.AddStruct(4, normalAOffset.Value, 0); }
  public static void AddNormalB(FlatBufferBuilder builder, Offset<Veneris.Communications.Vec3> normalBOffset) { builder.AddStruct(5, normalBOffset.Value, 0); }
  public static void AddMaterial(FlatBufferBuilder builder, Offset<Veneris.Communications.MaterialEMP> materialOffset) { builder.AddStruct(6, materialOffset.Value, 0); }
  public static void AddFaid(FlatBufferBuilder builder, uint faid) { builder.AddUint(7, faid, 0); }
  public static void AddFbid(FlatBufferBuilder builder, uint fbid) { builder.AddUint(8, fbid, 0); }
  public static void AddId(FlatBufferBuilder builder, int id) { builder.AddInt(9, id, 0); }
  public static Offset<Veneris.Communications.OpalEdge> EndOpalEdge(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.OpalEdge>(o);
  }
  public static void FinishOpalEdgeBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.OpalEdge> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedOpalEdgeBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.OpalEdge> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
